/*
OpenFire, a electrical Firework

License:
"OpenFire" by Jennifer Sirtl (jennifer.sirtl@mostfun.de) is licensed under CC BY 4.0

<a rel="license" href="http://creativecommons.org/licenses/by/4.0/"><img alt="Creative Commons Lizenzvertrag" style="border-width:0" src="https://i.creativecommons.org/l/by/4.0/88x31.png" /></a>
<br />Dieses Werk ist lizenziert unter einer <a rel="license" href="http://creativecommons.org/licenses/by/4.0/">Creative Commons Namensnennung 4.0 International Lizenz</a>.

*/
#include "config.h"
#include "raise.h"

#ifdef SOUND_ON
extern DFPlayerMini_Fast myDFPlayer;
#endif

void Palm(uint32_t c, uint8_t wait,uint8_t Shape_Num) 
{
  uint16_t s, Beginn;
  int Frame, Led_Index,n;  
  unsigned long Pattern[NUM_LEDS_Strip];

  #ifdef SOUND_ON
	  myDFPlayer.play(2);  
  #endif
  Shoot_1(0xFF3200, 64,1); //Rise up
  #ifdef SOUND_ON
    myDFPlayer.play(6);  
  #endif
  
  Pattern[0]=0;
  Pattern[1]=c & Shape[Shape_Num][4];
  Pattern[2]=c & Shape[Shape_Num][3];
  Pattern[3]=c & Shape[Shape_Num][2];
  Pattern[4]=c & Shape[Shape_Num][1];
  Pattern[5]=c & Shape[Shape_Num][0];
    if (Shape_Num!=2) {
      Pattern[6]=c & 0xFFFFFF;
    }
    else {
      Pattern[6]=c & 0x000000;       
    }
    Beginn=6;

  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){      
          leds[Led_Index+(s*NUM_LEDS_Strip)]=Pattern[n]; 
        } 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(wait);  
  } 
  return;
}

  void PalmGlitter(uint32_t c, uint8_t wait,uint8_t Shape_Num){
  uint16_t i,s,p, Beginn, Tail;
  int Frame, Led_Index,n;  
  unsigned long Pattern[4][NUM_LEDS_Strip];

	#ifdef SOUND_ON
		myDFPlayer.play(2);  
	#endif
  Shoot_2(0xFF3200, 64,1); //Raise
  #ifdef SOUND_ON
    myDFPlayer.play(7);  
  #endif

  for (s=0;s<4;s++){
    for (i=0;i<NUM_LEDS_Strip;i++){
      Pattern[s][i]=0x000000;
    }
    
  }
  
  for (s=0;s<4;s++){
        Pattern[s][4]=0;
        Pattern[s][5]=c & Shape[Shape_Num][4];
        Pattern[s][6]=c & Shape[Shape_Num][3];
        Pattern[s][7]=c & Shape[Shape_Num][2];
        Pattern[s][8]=c & Shape[Shape_Num][1];
        Pattern[s][9]=c & Shape[Shape_Num][0];
        if (Shape_Num!=2) {
          Pattern[s][10]=c & 0xFFFFFF;
        }
        else {
          Pattern[s][10]=c & 0x000000;       
        }
        Beginn=10; p=0; Tail=4;
  }
  
  Pattern[0][3]=Shape[Shape_Num][0];
  Pattern[0][1]=Shape[Shape_Num][0];
  Pattern[0][0]=0x000000;
  Pattern[1][3]=Shape[Shape_Num][0];
  Pattern[1][0]=0x000000;
  Pattern[2][2]=Shape[Shape_Num][0];
  Pattern[2][1]=Shape[Shape_Num][0];
  Pattern[3][1]=Shape[Shape_Num][0];
  Pattern[3][0]=0x000000;
 
  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){
    Led_Index=Frame;
    for(n=Tail;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){      
          leds[Led_Index+(s*NUM_LEDS_Strip)]=Pattern[p][n]; 
          p++;
          p=p & 0x03;
        } 
      }
      Led_Index++;
    }
    
    Led_Index=Frame-Tail;
    for(n=0;n<Tail;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){      
          if (random(10)<3) leds[Led_Index+(s*NUM_LEDS_Strip)]=Pattern[p][n]; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(10);    
    Led_Index=Frame-Tail;
    for(n=0;n<Tail;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){      
          leds[Led_Index+(s*NUM_LEDS_Strip)]=0x000000; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();   
    delay(wait);  
  } 
  return;
}


void Paeony(uint32_t c, uint8_t wait,uint8_t Shape_Num) 
{
  uint16_t Beginn;
  int Frame, Led_Index,n;  ;
  unsigned long Pattern[NUM_LEDS_Strip];

  #ifdef SOUND_ON
  myDFPlayer.play(2);  
  #endif
  Shoot_2(0xFF3200, 64,1); //Rise
  #ifdef SOUND_ON
	myDFPlayer.play(21);  
  #endif

  Pattern[0]=0;
  Pattern[1]=0x000000;//c & Shape[Shape_Num][4];
  Pattern[2]=0x000000;//c & Shape[Shape_Num][3];
  Pattern[3]=c & Shape[Shape_Num][4];
  Pattern[4]=c & Shape[Shape_Num][3];
  Pattern[5]=c & Shape[Shape_Num][0];
  if (Shape_Num!=2) {
    Pattern[6]=c & 0xFFFFFF;
  }
  else {
    Pattern[6]=c & 0x000000;       
  }
  Beginn=6;

  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
          leds[Led_Index  ]=Pattern[n]; 
          leds[Led_Index+(NUM_LEDS_Strip)]=Pattern[n]; 
          leds[Led_Index+(2*NUM_LEDS_Strip)]=Pattern[n]; 
          leds[Led_Index+(3*NUM_LEDS_Strip)]=Pattern[n]; 
          leds[Led_Index+(16*NUM_LEDS_Strip)]=Pattern[n]; 
          leds[Led_Index+(17*NUM_LEDS_Strip)]=Pattern[n]; 
          leds[Led_Index+(18*NUM_LEDS_Strip)]=Pattern[n]; 
          leds[Led_Index+(19*NUM_LEDS_Strip)]=Pattern[n]; 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(wait);  
  } 
  return;
}

void Sphere(uint32_t c, uint32_t d,  uint8_t wait,uint8_t Shape_Num) 
{
  uint16_t s, Beginn;
  int Frame, Led_Index,n;  
  unsigned long Pattern[NUM_LEDS_Strip];

  #ifdef SOUND_ON
  myDFPlayer.play(2);  
  #endif
  Shoot_2(0xFF3200, 64,2); //Raise
	#ifdef SOUND_ON
		myDFPlayer.play(3);
	#endif
  Pattern[0]=0;
  Pattern[1]=d & Shape[Shape_Num][3];;
  Pattern[2]=d & Shape[Shape_Num][0];;
  Pattern[3]=0;
  Pattern[4]=0;
  Pattern[5]=0;
  Pattern[6]=0;
  Pattern[7]=0;
  Pattern[8]=c & Shape[Shape_Num][3];
  Pattern[9]=c & Shape[Shape_Num][0];
  if (Shape_Num!=2) {
    Pattern[10]=c & 0xFFFFFF;
  }
  else {
    Pattern[10]=c & 0x000000;       
  }
  Beginn=10;
 
  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){      
          leds[Led_Index+(s*NUM_LEDS_Strip)]=Pattern[n]; 
        } 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(wait);  
  } 
  return;
}

void Waterfall(uint32_t c,  uint8_t wait,uint8_t Shape_Num) 
{
  uint16_t Beginn;
  int Frame, Led_Index,n;  
  unsigned long Pattern[NUM_LEDS_Strip];

  Shoot_2(0xFF3200, 64,1); //Raise
	#ifdef SOUND_ON  
		myDFPlayer.play(2);
	#endif
  Shoot_1(0x010101, wait,Shape_Num); //Rise up
  #ifdef SOUND_ON  
    myDFPlayer.play(22);
  #endif
 
  Pattern[0]=0;
  Pattern[1]=c & Shape[Shape_Num][4];
  Pattern[2]=c & Shape[Shape_Num][4];
  Pattern[3]=c & Shape[Shape_Num][4];
  Pattern[4]=c & Shape[Shape_Num][4];
  Pattern[5]=c & Shape[Shape_Num][4];
  Pattern[6]=c & Shape[Shape_Num][3];
  Pattern[7]=c & Shape[Shape_Num][3];
  Pattern[8]=c & Shape[Shape_Num][2];
  Pattern[9]=c & Shape[Shape_Num][2];
  Pattern[10]=c & Shape[Shape_Num][1];
  Pattern[11]=c & Shape[Shape_Num][1];
  Pattern[12]=c & Shape[Shape_Num][0];
  Pattern[13]=c & Shape[Shape_Num][0];
  
  if (Shape_Num!=2) {
    Pattern[14]=c & 0xFFFFFF;
  }
  else {
    Pattern[14]=c & 0x000000;       
  }
  Beginn=14;

  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
          leds[Led_Index+(9*NUM_LEDS_Strip)]=Pattern[n]; 
          leds[Led_Index+(10*NUM_LEDS_Strip)]=Pattern[n]; 
          leds[Led_Index+(13*NUM_LEDS_Strip)]=Pattern[n]; 
          leds[Led_Index+(14*NUM_LEDS_Strip)]=Pattern[n]; 
          leds[Led_Index+(17*NUM_LEDS_Strip)]=Pattern[n]; 
          leds[Led_Index+(18*NUM_LEDS_Strip)]=Pattern[n]; 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(wait);  
  } 
  return;
}
